libcamera: libcamera::ipa::ipu3::algorithms::ToneMapping Class Reference

libcamera v0.0.4 Supporting cameras in Linux since 2019

Loading...
Searching...
No Matches
Public Member Functions | List of all members
libcamera::ipa::ipu3::algorithms::ToneMapping Class Reference

A class to handle tone mapping based on gamma. More...

Inheritance diagram for libcamera::ipa::ipu3::algorithms::ToneMapping:
[legend]
Collaboration diagram for libcamera::ipa::ipu3::algorithms::ToneMapping:
[legend]

## Public Member Functions
int | configure (IPAContext &context, const IPAConfigInfo &configInfo) override
| Configure the tone mapping given a configInfo.
void | prepare (IPAContext &context, const uint32_t frame, IPAFrameContext &frameContext, ipu3_uapi_params *params) override
| Fill in the parameter structure, and enable gamma control.
void | process (IPAContext &context, const uint32_t frame, IPAFrameContext &frameContext, const ipu3_uapi_stats_3a *stats, ControlList &metadata) override
| Calculate the tone mapping look up table.
Public Member Functions inherited from libcamera::ipa::Algorithm< _Module >
virtual int | init (typename Module::Context &context, const YamlObject &tuningData)
| Initialize the Algorithm with tuning data.
virtual int | configure (typename Module::Context &context, const typename Module::Config &configInfo)
| Configure the Algorithm given an IPAConfigInfo.
virtual void | queueRequest (typename Module::Context &context, const uint32_t frame, typename Module::FrameContext &frameContext, const ControlList &controls)
| Provide control values to the algorithm.
virtual void | prepare (typename Module::Context &context, const uint32_t frame, typename Module::FrameContext &frameContext, typename Module::Params *params)
| Fill the params buffer with ISP processing parameters for a frame.
virtual void | process (typename Module::Context &context, const uint32_t frame, typename Module::FrameContext &frameContext, const typename Module::Stats *stats, ControlList &metadata)
| Process ISP statistics, and run algorithm operations.

## Additional Inherited Members
Public Types inherited from libcamera::ipa::Algorithm< _Module >
using | Module = _Module
| The IPA module type for this class of algorithms.

## Detailed Description

A class to handle tone mapping based on gamma.

This algorithm improves the image dynamic using a look-up table which is generated based on a gamma parameter.

## Member Function Documentation

## ◆ configure()

int libcamera::ipa::ipu3::algorithms::ToneMapping::configure | ( | IPAContext & | context,
|  | const IPAConfigInfo & | configInfo
| ) |  |
| override

Configure the tone mapping given a configInfo.

Parameters

  [in] | context | The shared IPA context
  [in] | configInfo | The IPA configuration data

Returns
  0

## ◆ prepare()

void libcamera::ipa::ipu3::algorithms::ToneMapping::prepare | ( | IPAContext & | context,
|  | const uint32_t | frame,
|  | IPAFrameContext & | frameContext,
|  | ipu3_uapi_params * | params
| ) |  |
| override

Fill in the parameter structure, and enable gamma control.

Parameters

  [in] | context | The shared IPA context
  [in] | frame | The frame context sequence number
  [in] | frameContext | The FrameContext for this frame
  [out] | params | The IPU3 parameters

Populate the IPU3 parameter structure with our tone mapping look up table and enable the gamma control module in the processing blocks.

## ◆ process()

void libcamera::ipa::ipu3::algorithms::ToneMapping::process | ( | IPAContext & | context,
|  | const uint32_t | frame,
|  | IPAFrameContext & | frameContext,
|  | const ipu3_uapi_stats_3a * | stats,
|  | ControlList & | metadata
| ) |  |
| override

Calculate the tone mapping look up table.

Parameters

  [in] | context | The shared IPA context
  [in] | frame | The current frame sequence number
  [in] | frameContext | The current frame context
  [in] | stats | The IPU3 statistics and ISP results
  [out] | metadata | Metadata for the frame, to be filled by the algorithm

The tone mapping look up table is generated as an inverse power curve from our gamma setting.

The documentation for this class was generated from the following files:

- src/ipa/ipu3/algorithms/tone_mapping.h
- src/ipa/ipu3/algorithms/tone_mapping.cpp